package com.example.accessiblespeech;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.example.accessiblespeech.model.Recording;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.ValueEventListener;

import java.io.File;
import java.util.ArrayList;

public class AdapterListItem extends ArrayAdapter<String> {
    Context contextAdapter;
    ArrayList<String> List = new ArrayList<>();
    String installationID;
    String keyToDelete;
    boolean deleteFlag;

    public AdapterListItem(@NonNull Context context, int resource, ArrayList<String> arrayList, String installationID) {
        super(context, resource);
        this.contextAdapter = context;
        this.List=arrayList;
        this.installationID = installationID;
    }

    @Override
    public int getCount(){
        return  List.size();
    }

    @NonNull
    @Override
    public View getView(int position, @Nullable View convertView, @NonNull ViewGroup parent){
        LayoutInflater inflater = (LayoutInflater) contextAdapter.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        View view = inflater.inflate(R.layout.list_item_delete,parent, false);
        TextView textView = (TextView)view.findViewById(R.id.textItem);
        Button delete =(Button)view.findViewById(R.id.deleteButtom);
        String name = List.get(position);
        textView.setText(name);
        deleteFlag = false;

        delete.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                deleteFlag = true;
                List.remove(position);
                DatabaseReference db = FirebaseDatabase.getInstance().getReference("devices/"+installationID);
                db.addValueEventListener(new ValueEventListener() {
                    @Override
                    public void onDataChange(@NonNull DataSnapshot snapshot) {
                        for(DataSnapshot dataSnapshot: snapshot.child("recordings").getChildren()){
                            if ((dataSnapshot.child("name").getValue()).equals(name)){
                                if(deleteFlag) {
                                    keyToDelete = dataSnapshot.getKey();
                                    String filepath = (String) dataSnapshot.child("filepath").getValue();
                                    File file = new File(filepath);
                                    file.delete();
                                    db.child("recordings").child(keyToDelete).removeValue();
                                }
                            }
                        }
                        for(DataSnapshot dataSnapshot: snapshot.child("categories").getChildren()){
                            String catKey = dataSnapshot.getKey();
                            for(DataSnapshot dataSnapshot1: dataSnapshot.child("recordings").getChildren()){
                                if ((dataSnapshot1.getKey()).equals(keyToDelete)){
                                    if(deleteFlag) {
                                        db.child("categories").child(catKey).child("recordings").child(keyToDelete).removeValue();
                                    }
                                }
                            }
                        }
                        deleteFlag = false;
                        keyToDelete = null;
                    }

                    @Override
                    public void onCancelled(@NonNull DatabaseError error) {
                        System.out.println("getting recordings failed");
                    }
                });
            }
        });
        return view;
    }

}
