package com.example.accessiblespeech;

import androidx.annotation.NonNull;
import androidx.appcompat.app.ActionBar;
import androidx.appcompat.app.AppCompatActivity;

import android.os.Bundle;
import android.content.Intent;
import android.text.Html;
import android.view.MenuItem;

import com.google.android.material.bottomnavigation.BottomNavigationView;
import android.widget.RadioButton;
import android.widget.RadioGroup;

public class SettingsActivity extends AppCompatActivity {
    private RadioGroup group;
    int currentTheme;
    private RadioButton blue;
    private RadioButton purple;
    private RadioButton green;
    private BottomNavigationView bottomBar3;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        ThemeUtils.onCreateSetTheme(this);
        setContentView(R.layout.activity_settings);
        bottomBar3 = findViewById(R.id.bottomBar3);
        bottomBar3.setSelectedItemId(R.id.settings_page);
        group = findViewById(R.id.radio_group);
        blue = findViewById(R.id.blue_theme);
        purple = findViewById(R.id.purple_theme);
        green = findViewById(R.id.green_theme);

        ActionBar actionBar = getSupportActionBar();
        actionBar.setTitle(Html.fromHtml("<font color='#656565'>AccessibleSpeech</font>"));

        currentTheme = getSharedPreferences("preferences", 0).getInt("theme", currentTheme);
        if(currentTheme == 0)
            blue.toggle();
        else if(currentTheme == 1)
            purple.toggle();
        else if(currentTheme == 2)
            green.toggle();

        group.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                RadioButton button = group.findViewById(checkedId);
                int i = group.indexOfChild(button);
                if(i == 0) {
                    ThemeUtils.changeTheme(SettingsActivity.this, 0);
                    ((GlobalUtils) getApplication()).setChangeThemeMain(true);
                    ((GlobalUtils) getApplication()).setChangeThemeTTS(true);
                }
                else if(i == 1) {
                    ThemeUtils.changeTheme(SettingsActivity.this, 1);
                    ((GlobalUtils) getApplication()).setChangeThemeMain(true);
                    ((GlobalUtils) getApplication()).setChangeThemeTTS(true);
                }
                else if(i == 2) {
                    ThemeUtils.changeTheme(SettingsActivity.this, 2);
                    ((GlobalUtils) getApplication()).setChangeThemeMain(true);
                    ((GlobalUtils) getApplication()).setChangeThemeTTS(true);
                }
            }
        });

        bottomBar3.setOnNavigationItemSelectedListener(new BottomNavigationView.OnNavigationItemSelectedListener() {
            @Override
            public boolean onNavigationItemSelected(@NonNull MenuItem item) {
                if(item.getItemId()== R.id.tts_page) {
                    Intent intent = new Intent(SettingsActivity.this, TTSActivity.class);
                    intent.addFlags(Intent.FLAG_ACTIVITY_REORDER_TO_FRONT);
                    startActivity(intent);
                } if(item.getItemId()== R.id.recordings_page) {
                    Intent intent = new Intent(SettingsActivity.this, MainActivity.class);
                    intent.addFlags(Intent.FLAG_ACTIVITY_REORDER_TO_FRONT);
                    startActivity(intent);
                }
                return false;
            }
        });
    }
}