package com.example.accessiblespeech;

import androidx.annotation.NonNull;
import androidx.appcompat.app.ActionBar;
import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.content.SharedPreferences;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.text.Html;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.TextView;

import com.example.accessiblespeech.model.Recording;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.ValueEventListener;

import java.io.IOException;
import java.util.ArrayList;

public class SpecificRecordingsActivity extends AppCompatActivity {
    private ListView list2;
    private String key;
    private String actualkey;
    private String recording;
    private String path;
    private MediaPlayer player = null;
    private Button button3;
    private TextView categoryheading;
    private long counter;
    private boolean updateCount;
    private String installationID;
    private String[] categoriesKeys = new String[7];
    private boolean flag;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        ThemeUtils.onCreateSetTheme(this);
        setContentView(R.layout.activity_specific_recordings);
        list2 =  findViewById(R.id.list2);
        actualkey = "";
        button3 = (Button) findViewById(R.id.button3);
        categoryheading = (TextView) findViewById(R.id.categoryheading);
        updateCount = true;
        flag = true;

        ActionBar actionBar = getSupportActionBar();
        actionBar.setTitle(Html.fromHtml("<font color='#656565'>AccessibleSpeech</font>"));

        SharedPreferences sharedPreferences = getSharedPreferences("preferences", 0);
        installationID = sharedPreferences.getString("installationID", installationID);
        categoriesKeys = ((GlobalUtils) getApplication()).getCategoryKeys();

        button3.setOnClickListener(new View.OnClickListener(){

            @Override
            public void onClick(View v) {
                openMain();
            }
        });

        Intent intent = getIntent();
        String key = intent.getStringExtra(MainActivity.TEXT_TO_SEND);

        if(key.equals("Health")){
            actualkey = categoriesKeys[0];
        }
        else if (key.equals("Shopping")){
            actualkey = categoriesKeys[1];
        }
        else if (key.equals("Social")){
            actualkey = categoriesKeys[2];
        }
        else if (key.equals("Food")){
            actualkey = categoriesKeys[3];
        }
        else if (key.equals("Questions")){
            actualkey = categoriesKeys[4];
        }
        else if (key.equals("Quick Replies")){
            actualkey = categoriesKeys[5];
        }
        else if (key.equals("Other")){
            actualkey = categoriesKeys[6];
        }
        else{
            System.out.println("Not a valid category name");
        }

        categoryheading.setText(key);
        final ArrayList<String> list1 = new ArrayList<>();
        final AdapterListItem adapter = new AdapterListItem(this, R.layout.list_item_delete, list1, installationID);
        list2.setAdapter(adapter);

        DatabaseReference reference2 = FirebaseDatabase.getInstance().getReference("devices/"+installationID+"/categories/"+actualkey+"/recordings");
        reference2.addValueEventListener(new ValueEventListener() {

            @Override
            public void onDataChange(@NonNull DataSnapshot snapshot) {
                list1.clear();
                for (DataSnapshot dataSnapshot : snapshot.getChildren()){
                    String c =  dataSnapshot.getKey();

                    DatabaseReference reference3 = FirebaseDatabase.getInstance().getReference("devices/"+installationID+"/recordings");
                    reference3.addValueEventListener(new ValueEventListener() {
                        @Override
                        public void onDataChange(@NonNull DataSnapshot snapshot) {
                            for(DataSnapshot dataSnapshot: snapshot.getChildren()){
                                if ((dataSnapshot.getKey()).equals(c)){
                                    Recording value = dataSnapshot.getValue(Recording.class);
                                    if(flag){
                                        list1.add(value.name);
                                    }
                                }
                            }
                            adapter.notifyDataSetChanged();
                        }

                        @Override
                        public void onCancelled(@NonNull DatabaseError error) {
                            System.out.println("getting recordings failed");
                        }
                    });
                }
            }

            @Override
            public void onCancelled(@NonNull DatabaseError error) {
                System.out.println("getting recording keys failed");
            }
        });

        list2.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                String recordingName = list1.get(position);
                DatabaseReference reference4 = FirebaseDatabase.getInstance().getReference("devices/"+installationID+"/recordings");
                reference4.addValueEventListener(new ValueEventListener() {
                    @Override
                    public void onDataChange(@NonNull DataSnapshot snapshot) {
                         for(DataSnapshot dataSnapshot:snapshot.getChildren()){
                             Recording recording = dataSnapshot.getValue(Recording.class);
                             if((recording.name).equals(recordingName)){
                                 DatabaseReference reference6 = FirebaseDatabase.getInstance().getReference("devices/"+installationID+"/recordings/"+dataSnapshot.getKey());
                                 long count = recording.getCounter()+1;
                                 if (updateCount) {
                                     reference6.child("counter").setValue(count);
                                     updateCount = false;
                                     flag = false;
                                     String path = recording.getFilepath();
                                     player = new MediaPlayer();
                                     try {
                                         player.setDataSource(path);
                                         player.prepare();
                                         player.start();
                                     } catch(IOException e) {
                                         Log.e("PlayTest", "failed");
                                     }
                                 }
                             }
                         }
                    }

                    @Override
                    public void onCancelled(@NonNull DatabaseError error) {
                        System.out.println("getting recordings failed");
                    }
                });
                updateCount = true;
            }
        });
    }

    public void openMain(){
        Intent intent = new Intent(this, MainActivity.class);
        startActivity(intent);
    }
}