package com.example.accessiblespeech;

import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;

import com.google.android.material.bottomnavigation.BottomNavigationView;

import androidx.annotation.NonNull;
import androidx.appcompat.app.ActionBar;
import androidx.appcompat.app.AppCompatActivity;

import android.speech.tts.TextToSpeech;
import android.text.Html;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;

import java.util.Locale;

public class TTSActivity extends AppCompatActivity {
    private EditText editText;
    private Button convert;
    private TextToSpeech text;
    private BottomNavigationView bottomBar2;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        ThemeUtils.onCreateSetTheme(this);
        setContentView(R.layout.activity_tts);
        editText = findViewById(R.id.textbox);
        convert = findViewById(R.id.convert);
        bottomBar2 = findViewById(R.id.bottomBar3);
        bottomBar2.setSelectedItemId(R.id.tts_page);

        ActionBar actionBar = getSupportActionBar();
        actionBar.setTitle(Html.fromHtml("<font color='#656565'>AccessibleSpeech</font>"));

        text = new TextToSpeech(getApplicationContext(), new TextToSpeech.OnInitListener() {
            @Override
            public void onInit(int status) {
                if(status != TextToSpeech.ERROR) {
                    text.setLanguage(Locale.CANADA);
                }
            }
        });

        convert.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String toSpeak = editText.getText().toString();;
                text.speak(toSpeak, TextToSpeech.QUEUE_FLUSH, null);
            }
        });

        bottomBar2.setOnNavigationItemSelectedListener(new BottomNavigationView.OnNavigationItemSelectedListener() {
            @Override
            public boolean onNavigationItemSelected(@NonNull MenuItem item) {
                if(item.getItemId()== R.id.settings_page){
                    Intent intent = new Intent(TTSActivity.this, SettingsActivity.class);
                    intent.addFlags(Intent.FLAG_ACTIVITY_REORDER_TO_FRONT);
                    startActivity(intent);
                } if(item.getItemId()== R.id.recordings_page) {
                    Intent intent = new Intent(TTSActivity.this, MainActivity.class);
                    intent.addFlags(Intent.FLAG_ACTIVITY_REORDER_TO_FRONT);
                    startActivity(intent);
                }
                return false;
            }
        });
    }

    @Override
    public void onResume(){
        super.onResume();
        if(((GlobalUtils) getApplication()).getChangeThemeTTS()){
            ((GlobalUtils) getApplication()).setChangeThemeTTS(false);
            recreate();
        }
    }
}